<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

/**
 * Модуль "Гостевая книга".
 *
 * <a href="http://wiki.a-cms.ru/modules/guestbook">Руководство</a>.
 */

class GuestbookModule extends A_MainFrame
{
/**
 * Маршрутизатор URL.
 *
 * @param array $uri Элементы полного пути URL.
 */

  function Router($uri)
  {
	if(count($uri)==0)
	$this->page="main";
	else
    A::NotFound();
  }

/**
 * Маршрутизатор действий.
 */

  function Action($action)
  {
    switch($action)
	{ case "addcomment": $this->AddComment(); break;
	}
  }

/**
 * Обработчик действия: Комментирование.
 */

  function AddComment()
  {
	if(!getAccess("comment"))
	return false;

	if(empty($_REQUEST['captcha']) || md5(strtolower($_REQUEST['captcha']))!=A_Session::get('captcha'))
	{ $this->errors['captcha']=true;
	  return false;
	}
	A_Session::unregister('captcha');

    $data=array();
    $data['date']=time();
	$data['idsec']=SECTION_ID;
	$data['iduser']=A::$AUTH->id;
	$data['name']=strip_tags($_REQUEST['name']);
    $data['bbcode']=$_REQUEST['message'];
    $data['message']=parse_bbcode($data['bbcode']);
    $data['active']=A::$OPTIONS['cactive']?'N':'Y';

	if(empty($data['name']) || empty($data['message']))
	return false;

    if($id=A::$DB->Insert(DOMAIN."_comments",$data))
	{
	  $link=getSectionLink(SECTION);

	  if(!empty(A::$OPTIONS['cemail']))
	  { if(!empty(A::$OPTIONS['commenttpl']))
		{ $item=array('name'=>SECTION_NAME,'link'=>"http://".HOSTNAME.$link);
	      $mail = new A_Mail(A::$OPTIONS['commenttpl'],"html");
		  $mail->Assign("item",$item);
		  $mail->Assign("comment",$data);
	      $mail->send(A::$OPTIONS['cemail']);
		}
	  }

	  if(A::$OPTIONS['cactive'])
	  A::goUrl($link.'?newcomment=1');
	  else
	  A::goUrl($link);
	}
	else
	return false;
  }

/**
 * Формирование данных доступных в шаблоне страницы.
 */

  function createData()
  {
    $this->Assign("content",getTextOption(SECTION,'content'));

    $rows=(integer)A::$OPTIONS['rows'];
    $sort=escape_order_string(A::$OPTIONS['sort']);

	$comments=array();
	$pager = new A_Pager($rows);
	$pager->query("SELECT * FROM ".DOMAIN."_comments WHERE idsec=".SECTION_ID." AND active='Y' ORDER BY $sort");
    while($row=$pager->fetchRow())
    { if($row['iduser']>0 && A::$AUTH->section)
	  { if($row['user']=A::$DB->getRowById($row['iduser'],A::$AUTH->section))
	    prepareValues(A::$AUTH->section,$row['user']);
	  }
	  $comments[]=$row;
    }
    $pager->free();
	$this->Assign("comments",$comments);
	$this->Assign("comments_pager",$pager);

	$form=array();
	$form['name']=!empty($_REQUEST['name'])?$_REQUEST['name']:(A::$AUTH->isLogin()?A::$AUTH->data['name']:"");
	$form['message']=!empty($_REQUEST['message'])?$_REQUEST['message']:"";
	$this->Assign("form",$form);

	$this->Assign("captcha",$captcha=substr(time(),rand(0,6),4));
	A_Session::set("captcha",md5($captcha));

	$this->AddNavigation(SECTION_NAME);
  }
}

A::$MAINFRAME = new GuestbookModule;