<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Modules
 */
/**************************************************************************/

/**
 * Интеграция в карту сайта.
 *
 * @param object &$treemap Объект дерева карты сайта.
 * @param string $section Полный строковой идентификатор раздела.
 * @param string $caption Название раздела.
 */

function guestbook_createMap($treemap,$section,$caption)
{
  $treemap->items[$section] = new SiteMap_Box($caption,getSectionLink($section));
}

/**
 * Индексация страницы в базу поиска по сайту.
 *
 * @param string $section Полный строковой идентификатор раздела.
 */

function guestbook_searchIndexAll($section)
{
  $idsec=getSectionId($section);
  $name=A::$DB->getOne("SELECT caption_".A::$LANG." FROM ".DOMAIN."_sections WHERE id=".$idsec);
  A_SearchEngine::getInstance()->updateIndex($idsec,0,$name,getTextOption($section,'content'));
}

/**
 * Интеграция вариантов доступа.
 *
 * @param array &$access Массив вариантов доступа.
 */

function guestbook_Access(&$access)
{
  $access[]=array('name'=>'comment','caption'=>"Комментирование",'auth'=>false);
}